//以下代码为utils.js内容
//配合《P114-118-模块化.js》使用

/*P114-模块化-导出模块*/
/*第一种导出方式*/

/**
 * 
 * @param {Date} date 
 * @returns 
*/
// export function formatDate(date){
//     return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}`
// }
/*讲了2个知识点
在function前面加上export关键字就可以完成导出
注释的使用，可以在下面使用的时候，直接有代码提示
没使用注释掉时候，date.输入到这有提示date和formateDate
使用了这个注释，date.输入到这会有很多Date对象的方法就出来了。
*/

/*P116-模块化-导出多个条目*/
/*VH：一个变量也可以导出？！
export function formatDate(date){
    return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}`
}
export const DAYS_OF_YEAR = 365;//如果不加const提示应有声明或语句
/** */

/*可以第二种导出方式
function formatDate(date){
    return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}`
}

const DAYS_OF_YEAR = 365;
export {formatDate,DAYS_OF_YEAR};
/** */

/*P117-模块化-默认导出
function formatDate(date){
    return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}`
}
const DAYS_OF_YEAR = 365;

export default formatDate;
export {DAYS_OF_YEAR};
/** */

/*测试是否可以混用：可以的
//formatDate()采用底部导出
//常量采用定义时导出
function formatDate(date){
    return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}`
}
export const DAYS_OF_YEAR = 365;
export default formatDate;
/** */

/*P118-模块化-别名
function formatDate(date){
    return `${date.getFullYear()}-${date.getMonth()}-${date.getDate()}`
}
const DAYS_OF_YEAR = 365;

export default formatDate;
export {DAYS_OF_YEAR};
/** */